import * as server from "@minecraft/server"

const world = server.world

let jackpot = {
    0: "slot_loot_diamond_jackpot",
    1: "slot_loot_emerald_jackpot",
    2: "slot_loot_netherite_jackpot",
    3: "slot_loot_lapiz_jackpot",
    4: "slot_loot_gold_jackpot",
    5: "slot_loot_iron_jackpot",
    6: "slot_loot_copper_jackpot",
    7: "slot_loot_coal_jackpot"
}

let smallprize = {
    0: "slot_loot_diamond_small",
    1: "slot_loot_emerald_small",
    2: "slot_loot_netherite_small",
    3: "slot_loot_lapiz_small",
    4: "slot_loot_gold_small",
    5: "slot_loot_iron_small",
    6: "slot_loot_copper_small",
    7: "slot_loot_coal_small"
}

server.system.afterEvents.scriptEventReceive.subscribe((data) => {

    if (data.id === "slot:getprize") {
        const entity = data.sourceEntity

        const reel1 = entity.getProperty("property:reel1")

        const reel2 = entity.getProperty("property:reel2")

        const reel3 = entity.getProperty("property:reel3")

        // console.warn(Reel1)

        if (reel1 === reel2 && reel1 === reel3) {

            entity.runCommandAsync(`playsound slot:jackpotsound @a ~ ~ ~ 1 1 1`)

            entity.runCommandAsync(`execute positioned ^ ^1 ^1.3 run loot spawn ~ ~ ~ loot "${jackpot[reel1]}"`)
        }
        else if (reel1 === reel2 && reel1 !== reel3) {

            entity.runCommandAsync(`playsound slot:smallprizesound @a ~ ~ ~ 1 1 1`)

            entity.runCommandAsync(`execute positioned ^ ^1 ^1.3 run loot spawn ~ ~ ~ loot "${smallprize[reel1]}"`)
        }
        else if (reel2 === reel3 && reel3 !== reel1) {

            entity.runCommandAsync(`playsound slot:smallprizesound @a ~ ~ ~ 1 1 1`)

            entity.runCommandAsync(`execute positioned ^ ^1 ^1.3 run loot spawn ~ ~ ~ loot "${smallprize[reel3]}"`)
        }
    }
})

world.afterEvents.projectileHitEntity.subscribe((data) => {

    const hook = data.projectile

    const slot = data.getEntityHit()


    if (hook.typeId === "minecraft:fishing_hook" && slot.entity.typeId === "slot:slot_machine") {

        hook.remove()

    }
})